MODULE MODE_POSNAM_PHY
IMPLICIT NONE
PRIVATE
PUBLIC :: POSNAM_PHY
CONTAINS
SUBROUTINE POSNAM_PHY(TFILENAM, CDNAML, LDNEEDNAM, LDFOUND)

!Wrapper to call the Meso-NH version of posnam

USE MODE_MSG, ONLY: NVERB_FATAL, PRINT_MSG
USE MODE_POS, ONLY: POSNAM
USE MODD_IO,  ONLY: TFILEDATA

IMPLICIT NONE

TYPE(TFILEDATA),  INTENT(IN)    :: TFILENAM    !< Namelist file
CHARACTER(LEN=*), INTENT(IN)    :: CDNAML    !< Namelist name
LOGICAL,          INTENT(IN)    :: LDNEEDNAM !< True to abort if namelist is absent
LOGICAL,          INTENT(OUT)   :: LDFOUND   !< True if namelist has been found

CALL POSNAM(TFILENAM, CDNAML, LDFOUND)
IF(LDNEEDNAM .AND. .NOT. LDFOUND) CALL PRINT_MSG(NVERB_FATAL, 'GEN', 'POSNAM_PHY', 'CANNOT LOCATE '//CDNAML)

END SUBROUTINE POSNAM_PHY

END MODULE MODE_POSNAM_PHY
