MODULE GETDATA_RAIN_ICE_OLD_MOD

USE OMP_LIB
USE ARRAYS_MANIP, ONLY: SETUP, REPLICATE, NPROMIZE, INTERPOLATE, SET
USE PARKIND1, ONLY: JPRD
USE ISO_FORTRAN_ENV, ONLY: OUTPUT_UNIT

CONTAINS

SUBROUTINE GETDATA_RAIN_ICE_OLD(NPROMA, NGPBLKS, NFLEVG, KRR,             &
                              OSEDIC, OCND2, LKOGAN, LMODICEDEP, OWARM, &
                              KKA, KKU, KKL, KSPLITR,                   &
                              PTSTEP, CSEDIM, CSUBG_AUCV_RC,           &
                              PDZZ_B, PRHODJ_B, PRHODREF_B,             &
                              PEXNREF_B, PPABSM_B,                      &
                              PCIT_B, PCIT_OUT_B,                       &
                              PCLDFR_B,                                 &
                              PICLDFR_B, PSSIO_B, PSSIU_B, PIFR_B,      &
                              PTHT_B, PRT_B, PTHS_B, PTHS_OUT_B,        &
                              PRS_B, PRS_OUT_B,                         &
                              PSIGS_B, PSEA_B, PTOWN_B,                 &
                              ZINPRC_B, ZINPRC_OUT_B,                   &
                              PINPRR_B, PINPRR_OUT_B,                   &
                              PEVAP_B, PEVAP_OUT_B,                     &
                              PINPRS_B, PINPRS_OUT_B,                   &
                              PINPRG_B, PINPRG_OUT_B,                   &
                              PINPRH_B, PINPRH_OUT_B,                   &
                              PICENU_B, PKGN_ACON_B, PKGN_SBGR_B,       &
                              PFPR_B, PFPR_OUT_B, ODMICRO, LDVERBOSE)

USE IEEE_ARITHMETIC, ONLY : IEEE_SIGNALING_NAN, IEEE_VALUE

IMPLICIT NONE

INTEGER, PARAMETER :: IFILE = 77

INTEGER      :: KLON
INTEGER      :: KIDIA
INTEGER      :: KLEV

LOGICAL, INTENT(IN) :: LDVERBOSE

INTEGER, INTENT(OUT) :: NPROMA, NGPBLKS, NFLEVG, KRR
LOGICAL, INTENT(OUT) :: OSEDIC, OCND2, LKOGAN, LMODICEDEP, OWARM
INTEGER, INTENT(OUT) :: KKA, KKU, KKL, KSPLITR
REAL,    INTENT(OUT) :: PTSTEP

CHARACTER(LEN=4), INTENT(OUT) :: CSEDIM
CHARACTER(LEN=4), INTENT(OUT) :: CSUBG_AUCV_RC

REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PDZZ_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PRHODJ_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PRHODREF_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PEXNREF_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PPABSM_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PCIT_B, PCIT_OUT_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PCLDFR_B

REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PICLDFR_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PSSIO_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PSSIU_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PIFR_B

REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PTHT_B
REAL, ALLOCATABLE, DIMENSION(:,:,:,:), INTENT(OUT) :: PRT_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PTHS_B, PTHS_OUT_B
REAL, ALLOCATABLE, DIMENSION(:,:,:,:), INTENT(OUT) :: PRS_B,  PRS_OUT_B

REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: ZINPRC_B, ZINPRC_OUT_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRR_B, PINPRR_OUT_B
REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PEVAP_B,  PEVAP_OUT_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRS_B, PINPRS_OUT_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRG_B, PINPRG_OUT_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PINPRH_B, PINPRH_OUT_B

REAL, ALLOCATABLE, DIMENSION(:,:,:),   INTENT(OUT) :: PSIGS_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PSEA_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PTOWN_B

REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PICENU_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PKGN_ACON_B
REAL, ALLOCATABLE, DIMENSION(:,:),     INTENT(OUT) :: PKGN_SBGR_B

REAL, ALLOCATABLE, DIMENSION(:,:,:,:), INTENT(OUT) :: PFPR_B, PFPR_OUT_B

LOGICAL, ALLOCATABLE, DIMENSION(:,:,:), INTENT(OUT) :: ODMICRO


REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PDZZ
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PRHODJ
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PRHODREF
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PEXNREF
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PPABSM
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PCIT, PCIT_OUT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PCLDFR

REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PICLDFR
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PSSIO
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PSSIU
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PIFR

REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PTHT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:,:) :: PRT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PTHS, PTHS_OUT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:,:) :: PRS,  PRS_OUT

REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PSIGS
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PSEA
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PTOWN

REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PICENU
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PKGN_ACON
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PKGN_SBGR

REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: ZINPRC_OUT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PINPRR_OUT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:)   :: PEVAP_OUT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PINPRS_OUT
REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PINPRG_OUT

REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:,:,:) :: PFPR_OUT

REAL(KIND=JPRD), ALLOCATABLE, DIMENSION(:,:)     :: PINPRH_OUT

INTEGER :: NGPTOT

INTEGER :: IOFF, IBL
LOGICAL :: LLEXIST, LSPP
CHARACTER(LEN=32) :: CLFILE

CALL SETUP()

KRR=6
NGPTOT = NPROMA * NGPBLKS

IBL = 1
WRITE (CLFILE, '("data/",I8.8,".dat")') IBL
OPEN (IFILE, FILE=TRIM(CLFILE), FORM='UNFORMATTED', POSITION='REWIND')
READ (IFILE) KLON
READ (IFILE) KLEV
READ (IFILE) KRR
CLOSE (IFILE)

IF(LDVERBOSE) THEN
  WRITE(OUTPUT_UNIT, *) 'KLON:        ', KLON
  WRITE(OUTPUT_UNIT, *) 'KLEV:        ', KLEV
  WRITE(OUTPUT_UNIT, *) 'KRR:         ', KRR
ENDIF

IF (NFLEVG < 0) NFLEVG = KLEV

ALLOCATE (PDZZ_B          (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PRHODJ_B        (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PRHODREF_B      (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PEXNREF_B       (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PPABSM_B        (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PCIT_B          (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PCIT_OUT_B      (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PCLDFR_B        (NPROMA, NFLEVG, NGPBLKS))

ALLOCATE (PICLDFR_B       (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PSSIO_B         (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PSSIU_B         (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PIFR_B          (NPROMA, NFLEVG, NGPBLKS))

ALLOCATE (PTHT_B          (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PRT_B           (NPROMA, NFLEVG, KRR, NGPBLKS))
ALLOCATE (PTHS_B          (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PTHS_OUT_B      (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PRS_B           (NPROMA, NFLEVG, KRR, NGPBLKS))
ALLOCATE (PRS_OUT_B       (NPROMA, NFLEVG, KRR, NGPBLKS))

ALLOCATE (ZINPRC_B        (NPROMA, NGPBLKS))
ALLOCATE (ZINPRC_OUT_B    (NPROMA, NGPBLKS))
ALLOCATE (PINPRR_B        (NPROMA, NGPBLKS))
ALLOCATE (PINPRR_OUT_B    (NPROMA, NGPBLKS))
ALLOCATE (PEVAP_B         (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PEVAP_OUT_B     (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PINPRS_B        (NPROMA, NGPBLKS))
ALLOCATE (PINPRS_OUT_B    (NPROMA, NGPBLKS))
ALLOCATE (PINPRG_B        (NPROMA, NGPBLKS))
ALLOCATE (PINPRG_OUT_B    (NPROMA, NGPBLKS))

ALLOCATE (PSIGS_B         (NPROMA, NFLEVG, NGPBLKS))
ALLOCATE (PSEA_B          (NPROMA, NGPBLKS))
ALLOCATE (PTOWN_B         (NPROMA, NGPBLKS))

ALLOCATE (PICENU_B        (NPROMA, NGPBLKS))
ALLOCATE (PKGN_ACON_B     (NPROMA, NGPBLKS))
ALLOCATE (PKGN_SBGR_B     (NPROMA, NGPBLKS))

ALLOCATE (PFPR_B          (NPROMA, NFLEVG, KRR, NGPBLKS))
ALLOCATE (PFPR_OUT_B      (NPROMA, NFLEVG, KRR, NGPBLKS))

IF (KRR .EQ. 7) THEN
  ALLOCATE (PINPRH_B      (NPROMA, NGPBLKS))
  ALLOCATE (PINPRH_OUT_B  (NPROMA, NGPBLKS))
ENDIF

ALLOCATE (ODMICRO      (NPROMA, NFLEVG, NGPBLKS))

CALL SET (PDZZ_B)
CALL SET (PRHODJ_B)
CALL SET (PRHODREF_B)
CALL SET (PEXNREF_B)
CALL SET (PPABSM_B)
CALL SET (PCIT_B)
CALL SET (PCIT_OUT_B)
CALL SET (PCLDFR_B)

CALL SET (PICLDFR_B)
CALL SET (PSSIO_B)
CALL SET (PSSIU_B)
CALL SET (PIFR_B)

CALL SET (PTHT_B)
CALL SET (PRT_B)
CALL SET (PTHS_B)
CALL SET (PTHS_OUT_B)
CALL SET (PRS_B)
CALL SET (PRS_OUT_B)

CALL SET (ZINPRC_B)
CALL SET (ZINPRC_OUT_B)
CALL SET (PINPRR_B)
CALL SET (PINPRR_OUT_B)
CALL SET (PEVAP_B)
CALL SET (PEVAP_OUT_B)
CALL SET (PINPRS_B)
CALL SET (PINPRS_OUT_B)
CALL SET (PINPRG_B)
CALL SET (PINPRG_OUT_B)

CALL SET (PSIGS_B)
CALL SET (PSEA_B)
CALL SET (PTOWN_B)

CALL SET (PICENU_B)
CALL SET (PKGN_ACON_B)
CALL SET (PKGN_SBGR_B)

CALL SET (PFPR_B)
CALL SET (PFPR_OUT_B)

IF (KRR .EQ. 7) THEN
  CALL SET(PINPRH_B)
  CALL SET(PINPRH_OUT_B)
ENDIF

!CALL SET (ODMICRO)

IOFF = 0
IBL = 0
LLEXIST = .TRUE.

DO WHILE(LLEXIST)
  IBL = IBL + 1
  WRITE (CLFILE, '("data/",I8.8,".dat")') IBL

  INQUIRE (FILE=TRIM (CLFILE), EXIST=LLEXIST)

  IF (LDVERBOSE) PRINT *, TRIM (CLFILE)

  IF (.NOT. LLEXIST) EXIT

  OPEN (IFILE, FILE=TRIM (CLFILE), FORM='UNFORMATTED', POSITION='REWIND' )
  
  READ (IFILE) KLON
  READ (IFILE) KLEV
  READ (IFILE) KRR

  IF (IBL == 1) THEN
    ALLOCATE (PDZZ         (NGPTOT, KLEV, 1))
    ALLOCATE (PRHODJ       (NGPTOT, KLEV, 1))
    ALLOCATE (PRHODREF     (NGPTOT, KLEV, 1))
    ALLOCATE (PEXNREF      (NGPTOT, KLEV, 1))
    ALLOCATE (PPABSM       (NGPTOT, KLEV, 1))
    ALLOCATE (PCIT         (NGPTOT, KLEV, 1))
    ALLOCATE (PCLDFR       (NGPTOT, KLEV, 1))
    
    ALLOCATE (PICLDFR      (NGPTOT, KLEV, 1))
    ALLOCATE (PSSIO        (NGPTOT, KLEV, 1))
    ALLOCATE (PSSIU        (NGPTOT, KLEV, 1))
    ALLOCATE (PIFR         (NGPTOT, KLEV, 1))
    
    ALLOCATE (PTHT         (NGPTOT, KLEV, 1))
    ALLOCATE (PRT          (NGPTOT, KLEV, KRR, 1))
    ALLOCATE (PTHS         (NGPTOT, KLEV, 1))
    ALLOCATE (PRS          (NGPTOT, KLEV, KRR, 1))
    
    ALLOCATE (PSIGS        (NGPTOT, KLEV, 1))
    ALLOCATE (PSEA         (NGPTOT, 1))
    ALLOCATE (PTOWN        (NGPTOT, 1))
    
    ALLOCATE (PICENU       (NGPTOT, 1))
    ALLOCATE (PKGN_ACON    (NGPTOT, 1))
    ALLOCATE (PKGN_SBGR    (NGPTOT, 1))
    
    ALLOCATE (PCIT_OUT     (NGPTOT, KLEV, 1))
    ALLOCATE (PTHS_OUT     (NGPTOT, KLEV, 1))
    ALLOCATE (PRS_OUT      (NGPTOT, KLEV, KRR, 1))
    ALLOCATE (ZINPRC_OUT   (NGPTOT, 1))
    ALLOCATE (PINPRR_OUT   (NGPTOT, 1))
    ALLOCATE (PEVAP_OUT    (NGPTOT, KLEV, 1))
    ALLOCATE (PINPRS_OUT   (NGPTOT, 1))
    ALLOCATE (PINPRG_OUT   (NGPTOT, 1))
    
    ALLOCATE (PFPR_OUT     (NGPTOT, KLEV, KRR, 1))
    
    IF (KRR == 7) THEN
      ALLOCATE (PINPRH_OUT (NGPTOT, 1))
    ENDIF

    PICENU = 1.d0
    PKGN_ACON = 10.d0
    PKGN_SBGR = 1.d0
  ENDIF

  IF (IOFF+KLON > NGPTOT) THEN
    EXIT
  ENDIF

  READ (IFILE) KKA
  READ (IFILE) KKU
  READ (IFILE) KKL
  READ (IFILE) KSPLITR

  READ (IFILE) OSEDIC
  READ (IFILE) OCND2
  READ (IFILE) LKOGAN
  READ (IFILE) LMODICEDEP
  READ (IFILE) OWARM

  READ (IFILE) CSEDIM
  READ (IFILE) CSUBG_AUCV_RC

  READ (IFILE) PTSTEP

  READ (IFILE) PDZZ    (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PRHODJ  (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PRHODREF(IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PEXNREF (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PPABSM  (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PCIT    (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PCLDFR  (IOFF+1:IOFF+KLON, :, 1)

  READ (IFILE) PICLDFR (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PSSIO   (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PSSIU   (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PIFR    (IOFF+1:IOFF+KLON, :, 1)

  READ (IFILE) PTHT    (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PRT     (IOFF+1:IOFF+KLON, :, :, 1)
  READ (IFILE) PTHS    (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PRS     (IOFF+1:IOFF+KLON, :, :, 1)

  READ (IFILE) PSIGS   (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PSEA    (IOFF+1:IOFF+KLON, 1)
  READ (IFILE) PTOWN   (IOFF+1:IOFF+KLON, 1)

  READ (IFILE) LSPP
  IF (LSPP) THEN
    READ (IFILE) PICENU (IOFF+1:IOFF+KLON, 1)
  ENDIF

  READ (IFILE) LSPP
  IF (LSPP) THEN
    READ (IFILE) PKGN_ACON (IOFF+1:IOFF+KLON, 1)
  ENDIF

  READ (IFILE) LSPP
  IF (LSPP) THEN
    READ (IFILE) PKGN_SBGR (IOFF+1:IOFF+KLON, 1)
  ENDIF

  READ (IFILE) PCIT_OUT     (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PTHS_OUT     (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PRS_OUT      (IOFF+1:IOFF+KLON, :, :, 1)
  READ (IFILE) ZINPRC_OUT   (IOFF+1:IOFF+KLON, 1)
  READ (IFILE) PINPRR_OUT   (IOFF+1:IOFF+KLON, 1)
  READ (IFILE) PEVAP_OUT    (IOFF+1:IOFF+KLON, :, 1)
  READ (IFILE) PINPRS_OUT   (IOFF+1:IOFF+KLON, 1)
  READ (IFILE) PINPRG_OUT   (IOFF+1:IOFF+KLON, 1)

  READ (IFILE) PFPR_OUT     (IOFF+1:IOFF+KLON, :, :, 1)

  IF (KRR == 7) THEN
    READ (IFILE) PINPRH_OUT (IOFF+1:IOFF+KLON, 1)
  ENDIF

  CLOSE (IFILE)

  IOFF = IOFF + KLON

ENDDO

IF (NFLEVG /= KLEV) THEN
  CALL INTERPOLATE (NFLEVG, IOFF, PDZZ)
  CALL INTERPOLATE (NFLEVG, IOFF, PDZZ)
  CALL INTERPOLATE (NFLEVG, IOFF, PRHODJ)
  CALL INTERPOLATE (NFLEVG, IOFF, PRHODREF)
  CALL INTERPOLATE (NFLEVG, IOFF, PEXNREF)
  CALL INTERPOLATE (NFLEVG, IOFF, PPABSM)
  CALL INTERPOLATE (NFLEVG, IOFF, PCIT)
  CALL INTERPOLATE (NFLEVG, IOFF, PCLDFR)
  
  CALL INTERPOLATE (NFLEVG, IOFF, PICLDFR)
  CALL INTERPOLATE (NFLEVG, IOFF, PSSIO)
  CALL INTERPOLATE (NFLEVG, IOFF, PSSIU)
  CALL INTERPOLATE (NFLEVG, IOFF, PIFR)
  
  CALL INTERPOLATE (NFLEVG, IOFF, PTHT)
  CALL INTERPOLATE (NFLEVG, IOFF, PRT)
  CALL INTERPOLATE (NFLEVG, IOFF, PTHS)
  CALL INTERPOLATE (NFLEVG, IOFF, PRS)
  
  CALL INTERPOLATE (NFLEVG, IOFF, PSIGS)
!  CALL INTERPOLATE (NFLEVG, IOFF, PSEA)
!  CALL INTERPOLATE (NFLEVG, IOFF, PTOWN)
  
!  CALL INTERPOLATE (NFLEVG, IOFF, PICENU)
!  CALL INTERPOLATE (NFLEVG, IOFF, PKGN_ACON)
!  CALL INTERPOLATE (NFLEVG, IOFF, PKGN_SBGR)
  
  CALL INTERPOLATE (NFLEVG, IOFF, PCIT_OUT)
  CALL INTERPOLATE (NFLEVG, IOFF, PTHS_OUT)
  CALL INTERPOLATE (NFLEVG, IOFF, PRS_OUT)
!  CALL INTERPOLATE (NFLEVG, IOFF, ZINPRC_OUT)
!  CALL INTERPOLATE (NFLEVG, IOFF, PINPRR_OUT)
  CALL INTERPOLATE (NFLEVG, IOFF, PEVAP_OUT)
!  CALL INTERPOLATE (NFLEVG, IOFF, PINPRS_OUT)
!  CALL INTERPOLATE (NFLEVG, IOFF, PINPRG_OUT)
  
  CALL INTERPOLATE (NFLEVG, IOFF, PFPR_OUT)
  
!  IF (KRR == 7) THEN
!    CALL INTERPOLATE (NFLEVG, IOFF, PINPRH_OUT)
!  ENDIF

ENDIF

CALL REPLICATE (IOFF, PDZZ        (:, :, 1))
CALL REPLICATE (IOFF, PRHODJ      (:, :, 1))
CALL REPLICATE (IOFF, PRHODREF    (:, :, 1))
CALL REPLICATE (IOFF, PEXNREF     (:, :, 1))
CALL REPLICATE (IOFF, PPABSM      (:, :, 1))
CALL REPLICATE (IOFF, PCIT        (:, :, 1))
CALL REPLICATE (IOFF, PCLDFR      (:, :, 1))

CALL REPLICATE (IOFF, PICLDFR     (:, :, 1))
CALL REPLICATE (IOFF, PSSIO       (:, :, 1))
CALL REPLICATE (IOFF, PSSIU       (:, :, 1))
CALL REPLICATE (IOFF, PIFR        (:, :, 1))

CALL REPLICATE (IOFF, PTHT        (:, :, 1))
CALL REPLICATE (IOFF, PRT         (:, :, :, 1))
CALL REPLICATE (IOFF, PTHS        (:, :, 1))
CALL REPLICATE (IOFF, PRS         (:, :, :, 1))

CALL REPLICATE (IOFF, PSIGS       (:, :, 1))
CALL REPLICATE (IOFF, PSEA        (:, 1))
CALL REPLICATE (IOFF, PTOWN       (:, 1))

CALL REPLICATE (IOFF, PICENU      (:, 1))
CALL REPLICATE (IOFF, PKGN_ACON   (:, 1))
CALL REPLICATE (IOFF, PKGN_SBGR   (:, 1))

CALL REPLICATE (IOFF, PCIT_OUT    (:, :, 1))
CALL REPLICATE (IOFF, PTHS_OUT    (:, :, 1))
CALL REPLICATE (IOFF, PRS_OUT     (:, :, :, 1))
CALL REPLICATE (IOFF, ZINPRC_OUT  (:, 1))
CALL REPLICATE (IOFF, PINPRR_OUT  (:, 1))
CALL REPLICATE (IOFF, PEVAP_OUT   (:, :, 1))
CALL REPLICATE (IOFF, PINPRS_OUT  (:, 1))
CALL REPLICATE (IOFF, PINPRG_OUT  (:, 1))

CALL REPLICATE (IOFF, PFPR_OUT    (:, :, :, 1))

IF (KRR == 7) THEN
  CALL REPLICATE (IOFF, PINPRH_OUT      (:, 1))
ENDIF

CALL NPROMIZE (NPROMA, PDZZ,       PDZZ_B)
CALL NPROMIZE (NPROMA, PRHODJ,     PRHODJ_B)
CALL NPROMIZE (NPROMA, PRHODREF,   PRHODREF_B)
CALL NPROMIZE (NPROMA, PEXNREF,    PEXNREF_B)
CALL NPROMIZE (NPROMA, PPABSM,     PPABSM_B)
CALL NPROMIZE (NPROMA, PCIT,       PCIT_B)
CALL NPROMIZE (NPROMA, PCLDFR,     PCLDFR_B)

CALL NPROMIZE (NPROMA, PICLDFR,    PICLDFR_B)
CALL NPROMIZE (NPROMA, PSSIO,      PSSIO_B)  
CALL NPROMIZE (NPROMA, PSSIU,      PSSIU_B)  
CALL NPROMIZE (NPROMA, PIFR,       PIFR_B)   

CALL NPROMIZE (NPROMA, PTHT,       PTHT_B)
CALL NPROMIZE (NPROMA, PRT,        PRT_B)
CALL NPROMIZE (NPROMA, PTHS,       PTHS_B)
CALL NPROMIZE (NPROMA, PRS,        PRS_B)

CALL NPROMIZE (NPROMA, PSIGS,      PSIGS_B)
CALL NPROMIZE (NPROMA, PSEA,       PSEA_B)
CALL NPROMIZE (NPROMA, PTOWN,      PTOWN_B)

CALL NPROMIZE (NPROMA, PICENU,     PICENU_B)
CALL NPROMIZE (NPROMA, PKGN_ACON,  PKGN_ACON_B)
CALL NPROMIZE (NPROMA, PKGN_SBGR,  PKGN_SBGR_B)

CALL NPROMIZE (NPROMA, PCIT_OUT,   PCIT_OUT_B)
CALL NPROMIZE (NPROMA, PTHS_OUT,   PTHS_OUT_B)
CALL NPROMIZE (NPROMA, PRS_OUT,    PRS_OUT_B)
CALL NPROMIZE (NPROMA, ZINPRC_OUT, ZINPRC_OUT_B)
CALL NPROMIZE (NPROMA, PINPRR_OUT, PINPRR_OUT_B)
CALL NPROMIZE (NPROMA, PEVAP_OUT,  PEVAP_OUT_B)
CALL NPROMIZE (NPROMA, PINPRS_OUT, PINPRS_OUT_B)
CALL NPROMIZE (NPROMA, PINPRG_OUT, PINPRG_OUT_B)

CALL NPROMIZE (NPROMA, PFPR_OUT,   PFPR_OUT_B)

IF (KRR == 7) THEN
  CALL NPROMIZE (NPROMA, PINPRH_OUT, PINPRH_OUT_B)
ENDIF

END SUBROUTINE GETDATA_RAIN_ICE_OLD

END  MODULE
